Package ghidra.program.model.data

# Interface Pointer

All Superinterfaces:
  `DataType`

All Known Implementing Classes:
  `Pointer16DataType`, `Pointer24DataType`, `Pointer32DataType`, `Pointer40DataType`, `Pointer48DataType`, `Pointer56DataType`, `Pointer64DataType`, `Pointer8DataType`, `PointerDataType`

public interface Pointer extends DataType
Interface for pointers

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `NaP`
  Pointer representation used when unable to generate a suitable address

  ### Fields inherited from interface ghidra.program.model.data.DataType

  `CONFLICT_SUFFIX, DEFAULT, NO_LAST_CHANGE_TIME, NO_SOURCE_SYNC_TIME, TYPEDEF_ATTRIBUTE_PREFIX, TYPEDEF_ATTRIBUTE_SUFFIX, VOID`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DataType`
  `getDataType()`
  Returns the "pointed to" dataType
  `Pointer`
  `newPointer(DataType dataType)`
  Creates a pointer to the indicated data type.
  `default PointerTypedefBuilder`
  `typedefBuilder()`
  Construct a pointer-typedef builder base on this pointer.

  ### Methods inherited from interface ghidra.program.model.data.DataType

  `addParent, clone, copy, dataTypeAlignmentChanged, dataTypeDeleted, dataTypeNameChanged, dataTypeReplaced, dataTypeSizeChanged, dependsOn, encodeRepresentation, encodeValue, getAlignedLength, getAlignment, getCategoryPath, getDataOrganization, getDataTypeManager, getDataTypePath, getDefaultAbbreviatedLabelPrefix, getDefaultLabelPrefix, getDefaultLabelPrefix, getDefaultOffcutLabelPrefix, getDefaultSettings, getDescription, getDisplayName, getDocs, getLastChangeTime, getLastChangeTimeInSourceArchive, getLength, getMnemonic, getName, getParents, getPathName, getRepresentation, getSettingsDefinitions, getSourceArchive, getTypeDefSettingsDefinitions, getUniversalID, getValue, getValueClass, hasLanguageDependantLength, isDeleted, isEncodable, isEquivalent, isNotYetDefined, isZeroLength, removeParent, replaceWith, setCategoryPath, setDescription, setLastChangeTime, setLastChangeTimeInSourceArchive, setName, setNameAndCategory, setSourceArchive`

- ## Field Details

  - ### NaP

    static final String NaP
    Pointer representation used when unable to generate a suitable address
    See Also:
      - Constant Field Values

- ## Method Details

  - ### getDataType

    DataType getDataType()
    Returns the "pointed to" dataType
    Returns:
      referenced datatype (may be null)

  - ### newPointer

    Pointer newPointer(DataType dataType)
    Creates a pointer to the indicated data type.
    Parameters:
      `dataType` - the data type to point to.
    Returns:
      the newly created pointer.

  - ### typedefBuilder

    default PointerTypedefBuilder typedefBuilder()
    Construct a pointer-typedef builder base on this pointer.
    Other construction options are provided when directly instantiating a `PointerTypedefBuilder`. In addition the utility class `PointerTypedefInspector` can be used to easily determine pointer-typedef settings.
    Returns:
      pointer-typedef builder
    Throws:
      `IllegalArgumentException` - if an invalid name is specified or pointer does not have a datatype manager.